VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAppAudio"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&

Private Const Channels As Long = 2              ' Stereo
Private Const BitsPerSample As Long = 16        ' 16bit
Private Const SamplesPerSecond As Long = 44100  ' 44.1kHz
Private Const Duration As Double = 0.5          ' 0.5 Sekunden
Private Const WH_Riff As Long = 1179011410      ' "RIFF"
Private Const WH_Typ As Long = 1163280727       ' "WAVE"
Private Const WH_Fmt As Long = 544501094        ' "fmt "
Private Const WH_Data As Long = 1635017060      ' "DATA"
Private Const WAVE_FORMAT_PCM As Integer = 1    ' PCM
Private Const SND_MEMORY As Long = &H4          ' Wave aus dem Speicher abspielen
Private Const SND_ASYNC As Long = &H1           ' Asynchron abspielen

Private Const CLSID_MMDeviceEnumerator As String = "{BCDE0395-E52F-467C-8E3D-C4579291692E}"

Private Const IID_IMMDeviceEnumerator As String = "{A95664D2-9614-4F35-A746-DE8DB63617E6}"
Private Const IID_IAudioSessionManager2 As String = "{77AA99A0-1BD6-484F-8BC7-2C654C9A9B6F}"
Private Const IID_IAudioSessionControl2 As String = "{BFB7FF88-7239-4FC9-8FA2-07C950BE9C6D}"
Private Const IID_ISimpleAudioVolume As String = "{87CE5498-68D6-44E5-9215-6DA47EF883D8}"
Private Const IID_IAudioMeterInformation As String = "{C02216F6-8C67-4B5B-9D00-D008E73E0064}"

Private Const CLSCTX_INPROC_SERVER As Long = &H1&
Private Const CLSCTX_INPROC_HANDLER As Long = &H2&
Private Const CLSCTX_LOCAL_SERVER As Long = &H4&
Private Const CLSCTX_REMOTE_SERVER As Long = &H10&

Private Const CLSCTX_ALL As Long = CLSCTX_INPROC_SERVER Or _
                                   CLSCTX_INPROC_HANDLER Or _
                                   CLSCTX_LOCAL_SERVER Or _
                                   CLSCTX_REMOTE_SERVER

' ----==== Enums ====----
Private Enum vtb_Interfaces
    QueryInterface = 0          'IUnknown
    
    Activate = 3                'IMMDevice
    
    GetCount = 3                'IAudioSessionEnumerator
    GetSession = 4              'IAudioSessionEnumerator
    
    GetDefaultAudioEndpoint = 4 'IMMDeviceEnumerator
    
    GetSessionEnumerator = 5    'IAudioSessionManager2
    
    GetProcessId = 14           'IAudioSessionControl2
    
    SetMasterVolume = 3         'ISimpleAudioVolume
    GetMasterVolume = 4         'ISimpleAudioVolume
    SetMasterMute = 5           'ISimpleAudioVolume
    GetMasterMute = 6           'ISimpleAudioVolume
    
    GetPeakValue = 3            'IAudioMeterInformation
    GetMeteringChannelCount = 4 'IAudioMeterInformation
    GetChannelsPeakValues = 5   'IAudioMeterInformation
End Enum

Private Enum ERole
    eConsole = &H0&
    eMultimedia = &H1&
    eCommunications = &H2&
End Enum

Private Enum EDataFlow
    eRender = &H0&
    eCapture = &H1&
    eAll = &H2&
End Enum

' ----==== Type ====----
Private Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Private Type Wave_Header
    cRIFFHeader As Long
    nRIFFBytes As Long
    cDataTypeID As Long
    cFormatHeader As Long
    nFormatBytes As Long
    nFormatTag As Integer
    nChannels As Integer
    nSamplesPerSec As Long
    nAvgBytesPerSec As Long
    nBlockAlign As Integer
    nBitsPerSample As Integer
    cDataHeader As Long
    nDataBytes As Long
End Type

Private Type Wave_Data
    R As Integer
    L As Integer
End Type

' ----==== Ole32.dll Deklarationen ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long

' ----==== Kernel32.dll Deklarationen ====----
Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Sub Sleep Lib "kernel32.dll" ( _
                    ByVal lngMilliseconds As Long)

Private Declare Function GetCurrentProcessId Lib "kernel32.dll" () As Long

' ----==== Winmm.dll Deklarationen ====----
Private Declare Function PlaySoundData Lib "Winmm.dll" _
                         Alias "PlaySoundA" ( _
                         ByVal lpData As Long, _
                         ByVal hModule As Long, _
                         ByVal dwFlags As Long) As Long


' ----==== Variablen ====----
Private m_Init As Boolean
Private m_pIMMDevice As Long
Private m_pISimpleAudioVolume As Long
Private m_pIMMDeviceEnumerator As Long
Private m_pIAudioSessionControl As Long
Private m_pIAudioSessionControl2 As Long
Private m_pIAudioSessionManager2 As Long
Private m_pIAudioMeterInformation As Long
Private m_pIAudioSessionEnumerator As Long

' Hauptfunktion!
Public Function InitAppVolume() As Boolean

    Dim bRet As Boolean

    bRet = False

    If InitAppAudioVolume = True Then

        bRet = True
        m_Init = True

    End If

    InitAppVolume = bRet

End Function

' hierber kann man nochmal abfregen ob alles Ok ist
Public Property Get IsInit() As Boolean

    IsInit = m_Init

End Property

' Peak Value vom Master (0.0 - 1.0)
Public Function GetMasterPeak() As Single

    Dim sRet As Single
    Dim sPeak As Single

    If m_Init = True Then

        If Invoke(m_pIAudioMeterInformation, GetPeakValue, VarPtr(sPeak)) = S_OK Then

            sRet = sPeak

        End If

    End If

    GetMasterPeak = sRet

End Function

' Anzahl der Kanle, 1=Mono, 2=Stereo usw.
Public Function GetChannelCount() As Long

    Dim lRet As Long
    Dim lChannelCount As Long

    If m_Init = True Then

        If Invoke(m_pIAudioMeterInformation, GetMeteringChannelCount, _
            VarPtr(lChannelCount)) = S_OK Then

            lRet = lChannelCount

        End If

    End If

    GetChannelCount = lRet

End Function

' Peak Value der Kanle (0.0 - 1.0)
Public Function GetChannelPeak(lChannelCount) As Single()

    Dim sRet() As Single
    Dim sPeak() As Single

    If lChannelCount >= 1 Then

        ReDim sPeak(lChannelCount - 1)

        If m_Init = True Then

            If Invoke(m_pIAudioMeterInformation, GetChannelsPeakValues, _
                lChannelCount, VarPtr(sPeak(0))) = S_OK Then

                sRet() = sPeak()

            End If

        End If

    End If

    GetChannelPeak = sRet()

End Function

' Value vom MasterVolume (0.0 - 1.0)
Public Function GetVolume() As Single

    Dim sRet As Single
    Dim sVolume As Single

    If m_Init = True Then

        If Invoke(m_pISimpleAudioVolume, GetMasterVolume, VarPtr(sVolume)) = S_OK Then

            sRet = sVolume

        End If

    End If

    GetVolume = sRet

End Function

' Value fr MasterVolume (0.0 - 1.0)
Public Function SetVolume(Optional ByVal sVolume As Single = 1!) As Boolean

    Dim bRet As Boolean

    bRet = False

    If sVolume < 0! Then sVolume = 0!
    If sVolume > 1! Then sVolume = 1!

    If m_Init = True Then

        If Invoke(m_pISimpleAudioVolume, SetMasterVolume, sVolume, 0&) = S_OK Then

            bRet = True

        End If

    End If

    SetVolume = bRet

End Function

' Mute False=Off, True=On
Public Function GetMute() As Boolean

    Dim bRet As Boolean
    Dim lMute As Long

    If m_Init = True Then

        If Invoke(m_pISimpleAudioVolume, GetMasterMute, VarPtr(lMute)) = S_OK Then

            bRet = CBool(lMute)

        End If

    End If

    GetMute = bRet

End Function

' Mute False=Off, True=On
Public Function SetMute(Optional ByVal bMute As Boolean = False) As Boolean

    Dim bRet As Boolean

    bRet = False

    If m_Init = True Then

        If Invoke(m_pISimpleAudioVolume, SetMasterMute, CLng(bMute), 0&) = S_OK Then

            bRet = True

        End If

    End If

    SetMute = bRet

End Function

Private Sub Class_Initialize()

    m_Init = False

End Sub

Private Sub Class_Terminate()
    
    ' alle Interfaces freigeben
    Call modInterface.Release(m_pIAudioMeterInformation)
    Call modInterface.Release(m_pISimpleAudioVolume)
    Call modInterface.Release(m_pIAudioSessionControl2)
    Call modInterface.Release(m_pIAudioSessionControl)
    Call modInterface.Release(m_pIAudioSessionEnumerator)
    Call modInterface.Release(m_pIAudioSessionManager2)
    Call modInterface.Release(m_pIMMDevice)
    Call modInterface.Release(m_pIMMDeviceEnumerator)
    
End Sub

Private Function InitAppAudioVolume() As Boolean

    Dim bolRet As Boolean
    Dim bytWave() As Byte
    Dim lngPID As Long
    Dim lngCount As Long
    Dim lngIndex As Long
    Dim lngSamples As Long
    Dim lngSessionCount As Long
    Dim tWD() As Wave_Data
    Dim tWH As Wave_Header

    bolRet = False

    ' Ich erstelle hier eine kurze, leere, Wave die asynchron abgespielt wird.
    ' Dann suche ich die passende Audiosession ber die ProzessID raus und komme
    ' so an die Interfaces ISimpleAudioVolume und IAudioMeterInformation.
    '
    ' Gibt sicher noch andere Wege eine Audiosession zu erzeugen, aber mir ist gerade nichts
    ' besseres eingefallen als ber eine kurze abgespielte Wave. ;-)

    ' Anzahl der Sample berechnen
    lngSamples = SamplesPerSecond * Duration
    
    ' WaveHeader mit Daten fllen
    With tWH
        .nDataBytes = lngSamples * Channels * BitsPerSample / 8
        .cRIFFHeader = WH_Riff
        .nRIFFBytes = 36 + .nDataBytes
        .cDataTypeID = WH_Typ
        .cFormatHeader = WH_Fmt
        .nFormatBytes = 16
        .nFormatTag = WAVE_FORMAT_PCM
        .nChannels = Channels
        .nSamplesPerSec = SamplesPerSecond
        .nBlockAlign = Channels * BitsPerSample / 8
        .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
        .nBitsPerSample = BitsPerSample
        .cDataHeader = WH_Data
    End With
        
    ' Arrays dimensionieren
    ReDim tWD(lngSamples - 1)
    ReDim bytWave(LenB(tWH) + tWH.nDataBytes - 1)
    
    ' WaveHeader kopieren
    Call CopyMemory(bytWave(0), tWH, LenB(tWH))
    
    ' Wavedaten hinter dem WaveHeader kopieren
    Call CopyMemory(ByVal VarPtr(bytWave(0)) + LenB(tWH), tWD(0), tWH.nDataBytes)
    
    ' erzeugte Wave abspielen
    If PlaySoundData(VarPtr(bytWave(0)), 0&, SND_MEMORY Or SND_ASYNC) <> 0& Then

        Do

            ' kurze Pause
            Call Delay(0.1)

            ' IMMDeviceEnumerator erstellen
            If modInterface.CreateInterface(m_pIMMDeviceEnumerator, _
                CLSID_MMDeviceEnumerator, IID_IMMDeviceEnumerator) = True Then

                ' DefaultAudioEndpoint fr die Wiedergabe ermitteln -> IMMDevice
                If Invoke(m_pIMMDeviceEnumerator, GetDefaultAudioEndpoint, _
                    EDataFlow.eRender, ERole.eConsole, VarPtr(m_pIMMDevice)) = S_OK Then

                    ' IAudioSessionManager2 erstellen
                    If Invoke(m_pIMMDevice, Activate, VarPtr(Str2Guid(IID_IAudioSessionManager2)), _
                        CLSCTX_ALL, 0&, VarPtr(m_pIAudioSessionManager2)) = S_OK Then

                        ' IAudioSessionEnumerator erstellen
                        If Invoke(m_pIAudioSessionManager2, GetSessionEnumerator, _
                            VarPtr(m_pIAudioSessionEnumerator)) = S_OK Then

                            ' Anzahl der laufenden Audiosessions ermitteln
                            If Invoke(m_pIAudioSessionEnumerator, GetCount, _
                                VarPtr(lngSessionCount)) = S_OK Then

                                ' sind laufende Audiosessions vorhanden
                                If lngSessionCount >= 1 Then

                                    ' alle laufenden Audiosessions durchlaufen
                                    For lngIndex = 0 To lngSessionCount - 1

                                        ' IAudioSessionControl von laufender Audiosession
                                        ' erstellen
                                        If Invoke(m_pIAudioSessionEnumerator, GetSession, _
                                            lngIndex, VarPtr(m_pIAudioSessionControl)) = S_OK Then

                                            ' IAudioSessionControl2 erstellen
                                            If Invoke(m_pIAudioSessionControl, QueryInterface, _
                                                VarPtr(Str2Guid(IID_IAudioSessionControl2)), _
                                                VarPtr(m_pIAudioSessionControl2)) = S_OK Then

                                                ' ProzessID von laufender Audiosession
                                                ' ermitteln
                                                If Invoke(m_pIAudioSessionControl2, GetProcessId, _
                                                    VarPtr(lngPID)) = S_OK Then

                                                    ' ist die ermittelte ProzessID = der
                                                    ' ProzessID dieser Anwendung
                                                    If lngPID = GetCurrentProcessId Then

                                                        ' ISimpleAudioVolume erstellen
                                                        If Invoke(m_pIAudioSessionControl2, QueryInterface, _
                                                            VarPtr(Str2Guid(IID_ISimpleAudioVolume)), _
                                                            VarPtr(m_pISimpleAudioVolume)) = S_OK Then

                                                            ' IAudioMeterInformation
                                                            ' erstellen
                                                            If Invoke(m_pIAudioSessionControl2, QueryInterface, _
                                                                VarPtr(Str2Guid(IID_IAudioMeterInformation)), _
                                                                VarPtr(m_pIAudioMeterInformation)) = S_OK Then

                                                                ' Audiosession fr diese
                                                                ' Anwendung gefunden
                                                                bolRet = True

                                                                ' Schleife verlassen
                                                                Exit For

                                                            End If

                                                        End If

                                                    End If

                                                End If

                                                ' IAudioSessionControl2 freigeben
                                                Call modInterface.Release(m_pIAudioSessionControl2)

                                            End If

                                            ' IAudioSessionControl freigeben
                                            Call modInterface.Release(m_pIAudioSessionControl)

                                        End If

                                    Next

                                End If

                            End If

                        End If

                    End If

                End If

            End If

            If bolRet = False Then
                Call modInterface.Release(m_pIAudioMeterInformation)
                Call modInterface.Release(m_pISimpleAudioVolume)
                Call modInterface.Release(m_pIAudioSessionControl2)
                Call modInterface.Release(m_pIAudioSessionControl)
                Call modInterface.Release(m_pIAudioSessionEnumerator)
                Call modInterface.Release(m_pIAudioSessionManager2)
                Call modInterface.Release(m_pIMMDevice)
                Call modInterface.Release(m_pIMMDeviceEnumerator)
            End If
            
            lngCount = lngCount + 1

            ' max 5 Versuche, dann abbrechen
            If lngCount = 5 Then Exit Do

        Loop Until bolRet = True

    End If
    
    If bolRet = False Then
    
        MsgBox "Cant create Windows Audio Session.", vbOKOnly Or vbInformation, "Windows Audio Session."
        
    End If

    InitAppAudioVolume = bolRet

End Function

' ----==== Helper Func ====----
'
' ruft die Funktion OleInvoke im Modul modInterface auf
Private Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = modInterface.OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

' String -> GUID
Private Function Str2Guid(ByVal str As String) As GUID

    Dim pstr As Long
    
    pstr = StrPtr(str)
    
    Call CLSIDFromString(pstr, Str2Guid)
    
End Function

Private Sub Delay(ByVal SecsDelay As Single)

    Dim TimeOut   As Single
    Dim PrevTimer As Single

    PrevTimer = Timer
    TimeOut = PrevTimer + SecsDelay

    Do While PrevTimer < TimeOut

        Sleep 1
        DoEvents

        If Timer < PrevTimer Then TimeOut = TimeOut - 86400
        PrevTimer = Timer

    Loop

End Sub
